function [M,sigma,u,v]=sparseSVD(A,gamma,miu)
[m,n]= size(A);
gammabar= gamma/(gamma-1);
miubar= miu/(gamma-1);
u = 0;
A2= sum(A.^2,2);
[maxA imax]= max(A2);
N= 1:n;
M= imax;

sigma= sqrt(A2(imax));
v= A(imax,:)'/sigma;

% c=0;
trackNormV = [];
trackLengthM = [];
while 1 
%     c=c+1;
    v_old= v;
    M_old= M;
    
    u_bar= A(:,N)*v;
    
    M= ( -sum(A.^2,2) + gammabar*(A(:,N)*v).^2 - miubar ) > 0;
    
    % the next lines can be added to ensure that in case of no 1 entry in
    % M, the algorithm does not stock in this function. Uncomment u = 0; at
    % the begining of the code as well
    if length(find(M == 1)) == 0
        break;
    end
    u= u_bar(M)/norm(u_bar(M));
    v_bar= A(M,:)'*u_bar(M);
    sigma= norm(v_bar);
    v= v_bar/sigma;
    
    % trackNormV = [trackNormV (norm(v_old-v)/norm(v_old))];
    % trackLengthM = [trackLengthM sum(M ~= 0)];
    
    % if (norm(v_old-v)/norm(v_old)) < 1e-4 && length(M_old)==length(M)
    if norm(v_old-v)<1e-4 && length(M_old)==length(M)
        % plot(trackLengthM)
        % hold on;
        
        break;
    end
    
end

% c



